﻿


Public Class ViewerForm
    Dim rpt As New GrapeCity.ActiveReports.SectionReport()
    WithEvents btnJpegExport As New ToolStripButton()



    Sub btnJpegExport_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnJpegExport.Click
        Dim dlg As New FolderBrowserDialog()
        dlg.ShowDialog()

        If dlg.SelectedPath <> "" Then
            ExportJpeg(Viewer1.Document, dlg.SelectedPath)
        End If

    End Sub

    Private Sub ExportJpeg(ReportDocument As GrapeCity.ActiveReports.Document.SectionDocument, folderSavePath As String)
        Dim pageindex As Integer = 0


        For Each _pg As GrapeCity.ActiveReports.Document.Section.Page In ReportDocument.Pages

            _pg.Units = GrapeCity.ActiveReports.Document.Section.Units.Pixels
            Dim bmp As New Bitmap(CInt(_pg.Width), CInt(_pg.Height))
            Dim g As Graphics = Graphics.FromImage(bmp)
            g.FillRectangle(New SolidBrush(Color.White), 0, 0, bmp.Width, bmp.Height)
            _pg.Draw(g, New RectangleF(0, 0, _pg.Width, _pg.Height))
            bmp.Save(folderSavePath & "\" & "Page" & (pageindex + 1).ToString() & ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg)
            pageindex += 1
        Next
    End Sub

    Private Function GetPath(filename As String) As String
        Dim path As String = Application.StartupPath
        Dim pos As Integer = path.IndexOf("\bin")
        path = path.Substring(0, pos) & "\" & filename

        Return path
    End Function

    Private Sub ViewerForm_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        btnJpegExport.Text = "JPEG Export"
        Viewer1.Toolbar.MainBar.Items.Insert(Viewer1.Toolbar.MainBar.Items.Count, btnJpegExport)

        Dim rpt As New GrapeCity.ActiveReports.SectionReport()
        Dim xtr As New System.Xml.XmlTextReader(GetPath("Annotation.rpx"))
        rpt.LoadLayout(xtr)
        Dim ds As New GrapeCity.ActiveReports.Data.OleDBDataSource()
        ds.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & GetPath("NWIND.MDB") & ";Persist Security Info=False"
        ds.SQL = "SELECT * FROM Invoices ORDER BY Customers.CompanyName, OrderID"
        rpt.DataSource = ds
        rpt.Run()
        Viewer1.Document = rpt.Document
        xtr.Close()
    End Sub
End Class
